import sys
import struct
sections = []

i = 0
prev_marker = False
with open(sys.argv[1], 'rb') as fin:
  while True:
    v = fin.read(1)
    if v is None or len(v) == 0:
      break
    v = v[0]
  
    if prev_marker:
      if v != 0x0:
        sections.append((v, i - 1,))
      prev_marker = False
    else:
      if v == 0xff:
        prev_marker = True
    i += 1

better_sections = []

for idx, section in enumerate(sections):
  section_type, offset = section
  section_end = None
  if idx != len(sections) -1 :
    section_end = sections[idx + 1][1]
  better_sections.append((section_type, offset, section_end,))
sections = better_sections

base_filename = sys.argv[1].split('.')

end_of_header = None
first_dht = None
for idx, data in enumerate(sections):
  section_type, offset,section_end  = data 
  if section_type == 0xC2 and end_of_header is None:
    end_of_header = section_end 
  elif section_type == 0xC4 and first_dht is None:
   first_dht = idx


header = None
with open(sys.argv[1], 'rb') as fin:
  header = fin.read(end_of_header)
  

i = 0
sections_data = []
dhts = []
scans = []
for idx, section in enumerate(sections):
  if idx < first_dht:
    continue
  section_type, offset, section_end = section

  if section_type == 0xD9:
    break

  sections_data.append([])
  with open(sys.argv[1], 'rb') as fin:
    fin.seek(offset, 0 )
    j = 0
    while j < (section_end - offset):
      v = fin.read(1)
      if len(v) == 0:
        break
      sections_data[-1].append(v)
      j += 1
  if section_type == 0xC4:
    dhts.append(len(sections_data)-1)

  if section_type != 0xDA:
    continue
  scans.append(len(sections_data) -1)
  output_filename = "%s_prog%d.jpg" % (base_filename[0], i)
  with open(output_filename, 'wb') as fout:
    fout.write(header)
    for sd in sections_data:
      for v in sd:
        fout.write(v)
    fout.write(b'\xff\xd9')

  output_filename = "%s_scan%d.jpg" %(base_filename[0], i)
  i += 1 
  with open(output_filename, 'wb') as fout:
    fout.write(header)
    for k, sd in enumerate(sections_data):
      if k in dhts or k in [len(sections_data)-2, len(sections_data)- 1]:
        for v in sd:
          fout.write(v)
    fout.write(b'\xff\xd9')

output_filename = '%s_fractional.jpg' % (base_filename[0])
with open(output_filename, 'wb') as fout:
  fout.write(header)

  for k, sd in enumerate(sections_data):
    if k not in scans[0:3]:
      for v in sd:
        fout.write(v)
  fout.write(b'\xff\xd9')  


